#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "..\TeleToken\TeleToken.h"
#include "..\TeleToken\rijndael-alg-ref.h "

#include "..\ExCommon\Print16.c"

char *RandInitFileName="MyRandInitFile.bin";

int main(int argc, char * argv[])
{
HANDLE hRandInitFile;
BYTE RandInitTbl[TVTT_RAND_INIT_TBL_SIZE];
DWORD n;
DWORD Time,TTime;
BYTE RandTbl[16];

// przygotowanie tablicy inicjujcej wypenionej moliwie nieprzewidywaln wartociami
//  - metoda przykadowa prosta ale nie zalecana, naley zastosowa wasn metod
n=0;
while(n<TVTT_RAND_INIT_TBL_SIZE)
    {
    RandInitTbl[n]=(BYTE)GetTickCount();
    n++;
    };

// odczytanie pliku inicjujcego (o ile istnieje)
hRandInitFile=CreateFile(RandInitFileName,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
if (hRandInitFile!=INVALID_HANDLE_VALUE)
    {
    ReadFile(hRandInitFile,RandInitTbl,TVTT_RAND_INIT_TBL_SIZE,&n,NULL);
    // UWAGA! Nie nastpuje powodzenie poprawnoci odczytu poniewa jeli odczyt si nie uda to tablica
    //  jest ju wypeniona wartociami moliwie nieprzewidywalnymi
    //  - jest to metoda prosta ale nie zalecana, w rozwizaniu zalecanym powinno by zaimplementowane:
    //      * sprawdzenie poprawnoci odczytu
    //      * szyfrowanie pliku z tablic inicjalizujc
    //      * sprawdzenie oryginalnoci pliku (suma kontrolna, podpis cyfrowy, etc.)
    CloseHandle(hRandInitFile);
    };

// zainicjowanie Generatora liczb pseudolosowych
TVTT_RandInit(RandInitTbl);

// zapisanie nowej tablicy inicjujcej generator
TVTT_RandGetInit(RandInitTbl);
hRandInitFile=CreateFile(RandInitFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
if (hRandInitFile!=INVALID_HANDLE_VALUE)
    {
    WriteFile(hRandInitFile,RandInitTbl,TVTT_RAND_INIT_TBL_SIZE,&n,NULL);
    // UWAGA! nie nastpuje przeprowadzenie poprawnoci zapisu
    //  - naley zastosowa wasn obsug bdu zapisu zalen od potrzeb
    CloseHandle(hRandInitFile);
    };

// powyzsze kroki konieczne eby program przy nastpnym uruchomieniu
// wystartowa z innym stanem generatora liczb losowych
//  - wykonywane na wypadek zakoczenia programu bez zapisu ostatniego stanu generatora

// zbieranie wartoci losowych
//  ta operacja powinna by wykonywana w gwnej ptli obsugi wiadomoci
//  zdarzeniami moga by np.:
//  * moment wcinicia klawisza na klawiaturze (np. odczytany przez GetTickCount())
//  * kod wcinitego klawisza
//  * moment wcinicia przycisku myszki (np. odczytany przez GetTickCount())
//  * moment wcinicia poruszenia myszki (np. odczytany przez GetTickCount())
//  * kierunek przesunicia myszki
//  * inne mniej lub bardziej nieprzewidywalne zdaenia wystepujce w systemie
// ponisza procedura moe by przydatna przy pierwszym uruchomieniu programu gdy
//  nie ma jeszcze tablicy inicjujcej generator liczb pseudolosowych

printf("Generowanie liczb pseudolosowych:\n");
Time=GetTickCount()+1000;
TTime=GetTickCount()+10000;
n=0;
while (GetTickCount()<TTime)
    {
    n++;
    if (_kbhit())                                                           // oczekiwanie na wcinicie klawisza
        {
        TVTT_Randomize(0,GetTickCount());                                   // jako pierwsze rdo przyjto moment wcinicia klawisza
        TVTT_Randomize(1,_getch());                                         // jako drugie rdo przyjto kod wcinitego klawisza
        TVTT_Randomize(2,n);                                                // jako trzecie rdo przyjto moment wcisnicia klawisza wyraony w iloci obrotw petli
        }
    else
        Sleep(100);                                                         // zwrcenie czci czasu do systemu

    if (GetTickCount()>Time)                                                // "co jaki czas" wygenerowanie i wywietlenie wartosci pseudolosowej
        {
        Time=GetTickCount()+1000;
        TVTT_Rand(RandTbl);
        printf("\t");Print16(RandTbl);
        };
    };

printf("\n");

// zapisanie stanu generatora liczb pseudolosowych
TVTT_RandGetInit(RandInitTbl);
hRandInitFile=CreateFile(RandInitFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
if (hRandInitFile!=INVALID_HANDLE_VALUE)
    {
    WriteFile(hRandInitFile,RandInitTbl,TVTT_RAND_INIT_TBL_SIZE,&n,NULL);
    // UWAGA! nie nastpuje przeprowadzenie poprawnoci zapisu
    //  - naley zastosowa wasn obsug bdu zapisu zalen od potrzeb
    CloseHandle(hRandInitFile);
    };

return(0);
};
